package org.example.sb40635;

import java.time.Duration;

import org.springframework.boot.CommandLineRunner;
import org.springframework.boot.web.client.ClientHttpRequestFactories;
import org.springframework.boot.web.client.ClientHttpRequestFactorySettings;
import org.springframework.boot.web.client.RestTemplateBuilder;
import org.springframework.http.ResponseEntity;
import org.springframework.http.client.BufferingClientHttpRequestFactory;
import org.springframework.stereotype.Component;
import org.springframework.web.client.RestTemplate;

/**
 * @author Moritz Halbritter
 */
@Component
class CLR implements CommandLineRunner {
    private final RestTemplateBuilder builder;

    CLR(RestTemplateBuilder builder) {
        this.builder = builder;
    }

    @Override
    public void run(String... args) {
        RestTemplate restTemplate = this.builder
                .requestFactory(() ->
                        new BufferingClientHttpRequestFactory(ClientHttpRequestFactories.get(ClientHttpRequestFactorySettings.DEFAULTS)))
                .setReadTimeout(Duration.ofSeconds(1))
                .build();
        ResponseEntity<String> response = restTemplate.getForEntity("https://spring.io/", String.class);
        System.out.println("Got " + response.getStatusCode());
    }
}
